diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.40/src/lr-wpan/examples/lr-wpan-bootstrap.cc ns-3.41/src/lr-wpan/examples/lr-wpan-bootstrap.cc
--- ns-3.40/src/lr-wpan/examples/lr-wpan-bootstrap.cc	2023-09-27 13:30:37.670839000 -0700
+++ ns-3.41/src/lr-wpan/examples/lr-wpan-bootstrap.cc	2024-02-09 14:44:07.953790400 -0800
@@ -88,7 +88,7 @@
     // with the highest LQI value obtained from a passive scan and make
     // sure this coordinator allows association.
 
-    if (params.m_status == MLMESCAN_SUCCESS)
+    if (params.m_status == LrWpanMacStatus::SUCCESS)
     {
         // Select the coordinator with the highest LQI from the PAN Descriptor List
         int maxLqi = 0;
@@ -105,7 +105,8 @@
             }
 
             // Only request association if the coordinator is permitting association at this moment.
-            if (params.m_panDescList[panDescIndex].m_superframeSpec.IsAssocPermit())
+            SuperframeField superframe(params.m_panDescList[panDescIndex].m_superframeSpec);
+            if (superframe.IsAssocPermit())
             {
                 std::string addressing;
                 if (params.m_panDescList[panDescIndex].m_coorAddrMode == SHORT_ADDR)
@@ -133,6 +134,7 @@
                     assocParams.m_chPage = params.m_panDescList[panDescIndex].m_logChPage;
                     assocParams.m_coordPanId = params.m_panDescList[panDescIndex].m_coorPanId;
                     assocParams.m_coordAddrMode = params.m_panDescList[panDescIndex].m_coorAddrMode;
+                    CapabilityField capability;
 
                     if (params.m_panDescList[panDescIndex].m_coorAddrMode ==
                         LrWpanAddressMode::SHORT_ADDR)
@@ -140,7 +142,7 @@
                         assocParams.m_coordAddrMode = LrWpanAddressMode::SHORT_ADDR;
                         assocParams.m_coordShortAddr =
                             params.m_panDescList[panDescIndex].m_coorShortAddr;
-                        assocParams.m_capabilityInfo.SetShortAddrAllocOn(true);
+                        capability.SetShortAddrAllocOn(true);
                     }
                     else if (assocParams.m_coordAddrMode == LrWpanAddressMode::EXT_ADDR)
                     {
@@ -148,8 +150,9 @@
                         assocParams.m_coordExtAddr =
                             params.m_panDescList[panDescIndex].m_coorExtAddr;
                         assocParams.m_coordShortAddr = Mac16Address("ff:fe");
-                        assocParams.m_capabilityInfo.SetShortAddrAllocOn(false);
+                        capability.SetShortAddrAllocOn(false);
                     }
+                    assocParams.m_capabilityInfo = capability.GetCapability();
 
                     Simulator::ScheduleNow(&LrWpanMac::MlmeAssociateRequest,
                                            device->GetMac(),
@@ -206,8 +209,11 @@
     MlmeAssociateResponseParams assocRespParams;
 
     assocRespParams.m_extDevAddr = params.m_extDevAddr;
-    assocRespParams.m_status = LrWpanAssociationStatus::ASSOCIATED;
-    if (params.capabilityInfo.IsShortAddrAllocOn())
+    assocRespParams.m_status = LrWpanMacStatus::SUCCESS;
+    CapabilityField capability;
+    capability.SetCapability(params.capabilityInfo);
+
+    if (capability.IsShortAddrAllocOn())
     {
         // Truncate the extended address and make an assigned
         // short address based on this. This mechanism is not described by the standard.
@@ -242,14 +248,14 @@
     // and is only here for demonstration purposes.
     switch (params.m_status)
     {
-    case LrWpanMlmeCommStatus::MLMECOMMSTATUS_TRANSACTION_EXPIRED:
+    case LrWpanMacStatus::TRANSACTION_EXPIRED:
         std::cout << Simulator::Now().As(Time::S) << " Coordinator " << device->GetNode()->GetId()
                   << " [" << device->GetMac()->GetShortAddress() << " | "
                   << device->GetMac()->GetExtendedAddress() << "]"
                   << " MLME-comm-status.indication: Transaction for device " << params.m_dstExtAddr
                   << " EXPIRED in pending transaction list\n";
         break;
-    case LrWpanMlmeCommStatus::MLMECOMMSTATUS_NO_ACK:
+    case LrWpanMacStatus::NO_ACK:
         std::cout << Simulator::Now().As(Time::S) << " Coordinator " << device->GetNode()->GetId()
                   << " [" << device->GetMac()->GetShortAddress() << " | "
                   << device->GetMac()->GetExtendedAddress() << "]"
@@ -257,7 +263,7 @@
                   << " device registered in the pending transaction list\n";
         break;
 
-    case LrWpanMlmeCommStatus::MLMECOMMSTATUS_CHANNEL_ACCESS_FAILURE:
+    case LrWpanMacStatus::CHANNEL_ACCESS_FAILURE:
         std::cout << Simulator::Now().As(Time::S) << " Coordinator " << device->GetNode()->GetId()
                   << " [" << device->GetMac()->GetShortAddress() << " | "
                   << device->GetMac()->GetExtendedAddress() << "]"
@@ -276,7 +282,7 @@
     // Used by device higher layer to inform the results of a
     // association procedure from its mac layer.This is implemented by other protocol stacks
     // and is only here for demonstration purposes.
-    if (params.m_status == LrWpanMlmeAssociateConfirmStatus::MLMEASSOC_SUCCESS)
+    if (params.m_status == LrWpanMacStatus::SUCCESS)
     {
         std::cout << Simulator::Now().As(Time::S) << " Node " << device->GetNode()->GetId() << " ["
                   << device->GetMac()->GetShortAddress() << " | "
@@ -286,7 +292,7 @@
                   << " | CoordShort: " << device->GetMac()->GetCoordShortAddress()
                   << " | CoordExt: " << device->GetMac()->GetCoordExtAddress() << ")\n";
     }
-    else if (params.m_status == LrWpanMlmeAssociateConfirmStatus::MLMEASSOC_NO_ACK)
+    else if (params.m_status == LrWpanMacStatus::NO_ACK)
     {
         std::cout << Simulator::Now().As(Time::S) << " Node " << device->GetNode()->GetId() << " ["
                   << device->GetMac()->GetShortAddress() << " | "
@@ -305,7 +311,7 @@
 static void
 PollConfirm(Ptr<LrWpanNetDevice> device, MlmePollConfirmParams params)
 {
-    if (params.m_status == LrWpanMlmePollConfirmStatus::MLMEPOLL_CHANNEL_ACCESS_FAILURE)
+    if (params.m_status == LrWpanMacStatus::CHANNEL_ACCESS_FAILURE)
     {
         std::cout
             << Simulator::Now().As(Time::S) << " Node " << device->GetNode()->GetId() << " ["
@@ -313,14 +319,14 @@
             << device->GetMac()->GetExtendedAddress() << "]"
             << " MLME-poll.confirm:  CHANNEL ACCESS problem when sending a data request command.\n";
     }
-    else if (params.m_status == LrWpanMlmePollConfirmStatus::MLMEPOLL_NO_ACK)
+    else if (params.m_status == LrWpanMacStatus::NO_ACK)
     {
         std::cout << Simulator::Now().As(Time::S) << " Node " << device->GetNode()->GetId() << " ["
                   << device->GetMac()->GetShortAddress() << " | "
                   << device->GetMac()->GetExtendedAddress() << "]"
                   << " MLME-poll.confirm: Data Request Command FAILED (NO ACK).\n";
     }
-    else if (params.m_status != LrWpanMlmePollConfirmStatus::MLMEPOLL_SUCCESS)
+    else if (params.m_status != LrWpanMacStatus::SUCCESS)
     {
         std::cout << Simulator::Now().As(Time::S) << " Node " << device->GetNode()->GetId() << " ["
                   << device->GetMac()->GetShortAddress() << " | "
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.40/src/lr-wpan/examples/lr-wpan-ed-scan.cc ns-3.41/src/lr-wpan/examples/lr-wpan-ed-scan.cc
--- ns-3.40/src/lr-wpan/examples/lr-wpan-ed-scan.cc	2023-09-27 13:30:37.670839000 -0700
+++ ns-3.41/src/lr-wpan/examples/lr-wpan-ed-scan.cc	2024-02-09 14:44:07.953790400 -0800
@@ -56,7 +56,7 @@
 static void
 ScanConfirm(MlmeScanConfirmParams params)
 {
-    if (params.m_status == MLMESCAN_SUCCESS && params.m_scanType == MLMESCAN_ED)
+    if (params.m_status == LrWpanMacStatus::SUCCESS && params.m_scanType == MLMESCAN_ED)
     {
         std::cout << Simulator::Now().As(Time::S) << "| Scan status SUCCESSFUL\n";
         std::cout << "Results for Energy Scan:"
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.40/src/lr-wpan/examples/lr-wpan-mlme.cc ns-3.41/src/lr-wpan/examples/lr-wpan-mlme.cc
--- ns-3.40/src/lr-wpan/examples/lr-wpan-mlme.cc	2023-09-27 13:30:37.670839000 -0700
+++ ns-3.41/src/lr-wpan/examples/lr-wpan-mlme.cc	2024-02-09 14:44:07.953790400 -0800
@@ -64,7 +64,7 @@
 {
     // In the case of transmissions with the Ack flag activated, the transaction is only
     // successful if the Ack was received.
-    if (params.m_status == LrWpanMcpsDataConfirmStatus::IEEE_802_15_4_SUCCESS)
+    if (params.m_status == LrWpanMacStatus::SUCCESS)
     {
         NS_LOG_UNCOND(Simulator::Now().GetSeconds() << " secs | Transmission successfully sent");
     }
@@ -80,7 +80,7 @@
 void
 StartConfirm(MlmeStartConfirmParams params)
 {
-    if (params.m_status == MLMESTART_SUCCESS)
+    if (params.m_status == LrWpanMacStatus::SUCCESS)
     {
         NS_LOG_UNCOND(Simulator::Now().GetSeconds() << "Beacon status SUCCESSFUL");
     }
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.40/src/lr-wpan/examples/lr-wpan-orphan-scan.cc ns-3.41/src/lr-wpan/examples/lr-wpan-orphan-scan.cc
--- ns-3.40/src/lr-wpan/examples/lr-wpan-orphan-scan.cc	2023-09-27 13:30:37.670839000 -0700
+++ ns-3.41/src/lr-wpan/examples/lr-wpan-orphan-scan.cc	2024-02-09 14:44:07.953790400 -0800
@@ -68,7 +68,7 @@
 static void
 ScanConfirm(Ptr<LrWpanNetDevice> device, MlmeScanConfirmParams params)
 {
-    if (params.m_status == MLMESCAN_SUCCESS)
+    if (params.m_status == LrWpanMacStatus::SUCCESS)
     {
         std::cout << Simulator::Now().As(Time::S) << " Node " << device->GetNode()->GetId() << " ["
                   << device->GetMac()->GetShortAddress() << " | "
@@ -76,7 +76,7 @@
                   << "] MLME-SCAN.confirm: Active scan status SUCCESSFUL "
                   << "(Coordinator found and address assigned) \n";
     }
-    else if (params.m_status == MLMESCAN_NO_BEACON)
+    else if (params.m_status == LrWpanMacStatus::NO_BEACON)
     {
         std::cout << Simulator::Now().As(Time::S) << " Node " << device->GetNode()->GetId() << " ["
                   << device->GetMac()->GetShortAddress() << " | "
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.40/src/lr-wpan/model/lr-wpan-csmaca.cc ns-3.41/src/lr-wpan/model/lr-wpan-csmaca.cc
--- ns-3.40/src/lr-wpan/model/lr-wpan-csmaca.cc	2023-09-27 13:30:37.670839000 -0700
+++ ns-3.41/src/lr-wpan/model/lr-wpan-csmaca.cc	2024-02-09 14:44:07.953790400 -0800
@@ -115,14 +115,14 @@
 LrWpanCsmaCa::IsSlottedCsmaCa() const
 {
     NS_LOG_FUNCTION(this);
-    return (m_isSlotted);
+    return m_isSlotted;
 }
 
 bool
 LrWpanCsmaCa::IsUnSlottedCsmaCa() const
 {
     NS_LOG_FUNCTION(this);
-    return (!m_isSlotted);
+    return !m_isSlotted;
 }
 
 void
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.40/src/lr-wpan/model/lr-wpan-fields.cc ns-3.41/src/lr-wpan/model/lr-wpan-fields.cc
--- ns-3.40/src/lr-wpan/model/lr-wpan-fields.cc	2023-09-27 13:30:37.670839000 -0700
+++ ns-3.41/src/lr-wpan/model/lr-wpan-fields.cc	2024-02-09 14:44:07.953790400 -0800
@@ -35,6 +35,11 @@
     SetAssocPermit(false);
 }
 
+SuperframeField::SuperframeField(uint16_t bitmap)
+{
+    SetSuperframe(bitmap);
+}
+
 void
 SuperframeField::SetSuperframe(uint16_t superFrmSpec)
 {
@@ -156,28 +161,6 @@
     return superframe;
 }
 
-uint32_t
-SuperframeField::GetSerializedSize() const
-{
-    return 2; // 2 Octets (superframeSpec)
-}
-
-Buffer::Iterator
-SuperframeField::Serialize(Buffer::Iterator i) const
-{
-    i.WriteHtolsbU16(GetSuperframe());
-    return i;
-}
-
-Buffer::Iterator
-SuperframeField::Deserialize(Buffer::Iterator i)
-{
-    uint16_t superframe = i.ReadLsbtohU16();
-    SetSuperframe(superframe);
-
-    return i;
-}
-
 std::ostream&
 operator<<(std::ostream& os, const SuperframeField& superframeField)
 {
@@ -525,27 +508,6 @@
     m_allocAddr = (bitmap >> 7) & (0x01);          //!< Bit 7
 }
 
-uint32_t
-CapabilityField::GetSerializedSize() const
-{
-    return 1;
-}
-
-Buffer::Iterator
-CapabilityField::Serialize(Buffer::Iterator i) const
-{
-    i.WriteU8(GetCapability());
-    return i;
-}
-
-Buffer::Iterator
-CapabilityField::Deserialize(Buffer::Iterator i)
-{
-    uint8_t capability = i.ReadU8();
-    SetCapability(capability);
-    return i;
-}
-
 bool
 CapabilityField::IsDeviceTypeFfd() const
 {
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.40/src/lr-wpan/model/lr-wpan-fields.h ns-3.41/src/lr-wpan/model/lr-wpan-fields.h
--- ns-3.40/src/lr-wpan/model/lr-wpan-fields.h	2023-09-27 13:30:37.670839000 -0700
+++ ns-3.41/src/lr-wpan/model/lr-wpan-fields.h	2024-02-09 14:44:07.953790400 -0800
@@ -54,6 +54,14 @@
 {
   public:
     SuperframeField();
+
+    /**
+     * Create a superframe Specification Information field with
+     * the information specified in the bitmap.
+     *
+     * \param bitmap The superframe in bitmap form
+     */
+    SuperframeField(uint16_t bitmap);
     /**
      * Set the whole Superframe Specification Information field.
      * \param superFrm The Superframe Specification information field.
@@ -127,24 +135,6 @@
      * \return the Superframe Specification Information field bits.
      */
     uint16_t GetSuperframe() const;
-    /**
-     * Get the size of the serialized Superframe specification information field.
-     * \return the size of the serialized field.
-     */
-    uint32_t GetSerializedSize() const;
-    /**
-     * Serialize the entire superframe specification field.
-     * \param i an iterator which points to where the superframe specification field should be
-     * written.
-     * \return an iterator.
-     */
-    Buffer::Iterator Serialize(Buffer::Iterator i) const;
-    /**
-     * Deserialize the entire superframe specification field.
-     * \param i an iterator which points to where the superframe specification field should be read.
-     * \return an iterator.
-     */
-    Buffer::Iterator Deserialize(Buffer::Iterator i);
 
   private:
     // Superframe Specification field
@@ -378,30 +368,6 @@
     void SetCapability(uint8_t bitmap);
 
     /**
-     * Get the size of the serialized Capability Information Field.
-     *
-     * \return the size of the serialized field.
-     */
-    uint32_t GetSerializedSize() const;
-
-    /**
-     * Serialize the entire Capability Information Field.
-     *
-     * \param i an iterator which points to where the Capability information field
-     * should be written.
-     * \return an iterator.
-     */
-    Buffer::Iterator Serialize(Buffer::Iterator i) const;
-
-    /**
-     * Deserialize the entire Capability Information Field.
-     *
-     * \param i an iterator which points to where the Capability information field should be read.
-     * \return an iterator.
-     */
-    Buffer::Iterator Deserialize(Buffer::Iterator i);
-
-    /**
      * True if the device type is a Full Functional Device (FFD) false if is a Reduced Functional
      * Device (RFD).
      *
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.40/src/lr-wpan/model/lr-wpan-mac-base.cc ns-3.41/src/lr-wpan/model/lr-wpan-mac-base.cc
--- ns-3.40/src/lr-wpan/model/lr-wpan-mac-base.cc	1969-12-31 16:00:00.000000000 -0800
+++ ns-3.41/src/lr-wpan/model/lr-wpan-mac-base.cc	2024-02-09 14:44:07.953790400 -0800
@@ -0,0 +1,120 @@
+/*
+ * Copyright (c) 2023 Tokushima University, Japan.
+ *
+ * This program is free software; you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License version 2 as
+ * published by the Free Software Foundation;
+ *
+ * This program is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with this program; if not, write to the Free Software
+ * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
+ *
+ *  Author: Alberto Gallegos Ramonet <alramonet@is.tokushima-u.ac.jp>
+ */
+
+#include "lr-wpan-mac-base.h"
+
+#include <ns3/log.h>
+#include <ns3/uinteger.h>
+
+namespace ns3
+{
+
+NS_LOG_COMPONENT_DEFINE("LrWpanMacBase");
+NS_OBJECT_ENSURE_REGISTERED(LrWpanMacBase);
+
+TypeId
+LrWpanMacBase::GetTypeId()
+{
+    static TypeId tid = TypeId("ns3::LrWpanMacBase").SetParent<Object>().SetGroupName("LrWpan");
+    return tid;
+}
+
+LrWpanMacBase::~LrWpanMacBase()
+{
+}
+
+void
+LrWpanMacBase::SetMcpsDataConfirmCallback(McpsDataConfirmCallback c)
+{
+    m_mcpsDataConfirmCallback = c;
+}
+
+void
+LrWpanMacBase::SetMcpsDataIndicationCallback(McpsDataIndicationCallback c)
+{
+    m_mcpsDataIndicationCallback = c;
+}
+
+void
+LrWpanMacBase::SetMlmeAssociateIndicationCallback(MlmeAssociateIndicationCallback c)
+{
+    m_mlmeAssociateIndicationCallback = c;
+}
+
+void
+LrWpanMacBase::SetMlmeCommStatusIndicationCallback(MlmeCommStatusIndicationCallback c)
+{
+    m_mlmeCommStatusIndicationCallback = c;
+}
+
+void
+LrWpanMacBase::SetMlmeOrphanIndicationCallback(MlmeOrphanIndicationCallback c)
+{
+    m_mlmeOrphanIndicationCallback = c;
+}
+
+void
+LrWpanMacBase::SetMlmeStartConfirmCallback(MlmeStartConfirmCallback c)
+{
+    m_mlmeStartConfirmCallback = c;
+}
+
+void
+LrWpanMacBase::SetMlmeScanConfirmCallback(MlmeScanConfirmCallback c)
+{
+    m_mlmeScanConfirmCallback = c;
+}
+
+void
+LrWpanMacBase::SetMlmeAssociateConfirmCallback(MlmeAssociateConfirmCallback c)
+{
+    m_mlmeAssociateConfirmCallback = c;
+}
+
+void
+LrWpanMacBase::SetMlmeBeaconNotifyIndicationCallback(MlmeBeaconNotifyIndicationCallback c)
+{
+    m_mlmeBeaconNotifyIndicationCallback = c;
+}
+
+void
+LrWpanMacBase::SetMlmeSyncLossIndicationCallback(MlmeSyncLossIndicationCallback c)
+{
+    m_mlmeSyncLossIndicationCallback = c;
+}
+
+void
+LrWpanMacBase::SetMlmeSetConfirmCallback(MlmeSetConfirmCallback c)
+{
+    m_mlmeSetConfirmCallback = c;
+}
+
+void
+LrWpanMacBase::SetMlmeGetConfirmCallback(MlmeGetConfirmCallback c)
+{
+    m_mlmeGetConfirmCallback = c;
+}
+
+void
+LrWpanMacBase::SetMlmePollConfirmCallback(MlmePollConfirmCallback c)
+{
+    m_mlmePollConfirmCallback = c;
+}
+
+} // namespace ns3
